#include <avr32/io.h>
#include "macro.h"

.global debug_showRegister
.global debug_showMem

/**********************
*** debug_showRegister
*** INPUT: r8 = Number
**********************/
debug_showRegister:
    stm     --sp,r4,r7,r8,r9,lr

    mov     r9,r8
    swap.b  r9
    mov     r4,4
nextByte:
    bfextu  r8,r9,4,4
    sub     r8,-48
    cp      r8,57
    subhi   r8,-7
    mov     r7,1
    rcall   serialSendChar

    bfextu  r8,r9,0,4
    sub     r8,-48
    cp      r8,57
    subhi   r8,-7
    mov     r7,1
    rcall   serialSendChar

    lsr     r9,8
    sub     r4,1
    brne    nextByte

    ldm     sp++,r4,r7,r8,r9,pc


/**********************
*** debug_showMem
*** INPUT: r8 = start addr
*** INPUT: r7 = len
**********************/
debug_showMem:
    stm     --sp,r0,r1,r4,r8,r9,lr

    mov     r9,r8
    mov     r1,16
    mov     r0,r7

1:  ld.ub   r4,r9++
    bfextu  r8,r4,4,4
    sub     r8,-48
    cp      r8,57
    subhi   r8,-7
    mov     r7,1
    rcall   serialSendChar
    bfextu  r8,r4,0,4
    sub     r8,-48
    cp      r8,57
    subhi   r8,-7
    mov     r7,1
    rcall   serialSendChar

    sub     r1,1
    brne    2f
    mov     r1,16
    mov     r8,'\r'
    mov     r7,1
    rcall   serialSendChar
    mov     r8,'\n'
    mov     r7,1
    rcall   serialSendChar

    rjmp    3f
2:
    mov     r8,' '
    mov     r7,1
    rcall   serialSendChar
3:
    sub     r0,1
    brne    1b

    ldm     sp++,r0,r1,r4,r8,r9,pc


