#include <avr32/io.h>
#include "macro.h"

.global initEVBA
.global initInterrupts
.global EntryPoint

.extern dtlbMissWrite
.extern instructionAddress
.extern itlbProtection
.extern dataAddressRead
.extern dataAddressWrite
.extern dtlbProtectionRead
.extern dtlbProtectionWrite
.extern dtlbModified
.extern itlbMiss
.extern dtlbMissRead


.section .text

//WARNING: This must be aligned on a 8kb boundary!!
EntryPoint:
evbabase:
int0:       bral unrecoverableException
int1:       bral unknownException
int2:       bral unknownException
int3:       bral unknownException
int4:       bral unknownException
int5:       bral instructionAddress
int6:       bral itlbProtection
int7:       bral unknownException
int8:       bral illegalOpcode
int9:       bral unimplmentedInstruction
int10:      bral unknownException
int11:      bral unknownException
int12:      bral unknownException
int13:      bral dataAddressRead
int14:      bral dataAddressWrite
int15:      bral dtlbProtectionRead
int16:      bral dtlbProtectionWrite
int17:      bral dtlbModified
int18:      bral unknownException
int19:      bral unknownException
int20:      bral itlbMiss
int21:      bral unknownException
int22:      bral unknownException
int23:      bral unknownException
int24:      bral dtlbMissRead
int25:      bral unknownException
int26:      bral unknownException
int27:      bral unknownException
int28:      bral dtlbMissWrite
int29:      bral unknownException
int30:      bral unknownException
int31:      bral unknownException
int32:      bral unknownException
int33:      bral unknownException
int34:      bral unknownException
int35:      bral unknownException
int36:      bral unknownException
int37:      bral unknownException
int38:      bral unknownException
int39:      bral unknownException
int40:      bral unknownException
int41:      bral unknownException
int42:      bral unknownException
int43:      bral unknownException
int44:      bral unknownException
int45:      bral unknownException
int46:      bral unknownException
int47:      bral unknownException
int48:      bral unknownException
int49:      bral unknownException
int50:      bral unknownException
int51:      bral unknownException
int52:      bral unknownException
int53:      bral unknownException
int54:      bral unknownException
int55:      bral unknownException
int56:      bral unknownException
int57:      bral unknownException
int58:      bral unknownException
int59:      bral unknownException
int60:      bral unknownException
int61:      bral unknownException
int62:      bral unknownException
int63:      bral unknownException
int64:      bral supervisorCall

////////////////////////////////////
/// default IRQ
////////////////////////////////////
.align 4
catchAllInt:
    SERIALPRINTF("Unhandled interrupt\r\n")
    1:rjmp 1b


////////////////////////////////////
/// TIMER0 IRQ - scheduler
////////////////////////////////////
.align 4
intGrp22:
    lddpc   r10,.tcZero
    ld.w    r11,r10[AVR32_TC_SR0]                 // this will also reset the interrupt flag



    /*mfsr    r8,AVR32_PCCNT
    rcall   debug_showRegister
    mov     r11,0b111
    mtsr    AVR32_PCCR,r11
    SERIALPRINTF("\r\n")*/

    mfsr    r10,AVR32_TLBEHI
    andl    r10,0x1F,COH            // r10 = current ASID index
    sub     r11,r10,-1              // r11 = next ASID
    mov     r12,0x1000
    orh     r12,0x0400              // r12 = process table
1:  ld.w    r9,r12[r11<<2]
    cp      r9,0
    brne    foundNext
    sub     r11,-1                  // next ASID
    andl    r11,0x1F,COH            // wrap around 32
    cp      r11,r10                 // are we back to the starting point?
    brne    1b

    /* ASID is the same, don't do any context switch */
    rjmp    exitSchedulerIRQ

foundNext:                          // at this point, r11 contains the next ASID
    cp      r10,0
    breq    loadContext             // skip "save context" if this is the kernel
    /* Save current context */
    mov     r10,TASKCONTEXT_BASE
    stmts   r10,r0-r14
    mfsr    r12,AVR32_RAR_INT3
    st.w    r10[TASKCONTEXT_RAR],r12
    mfsr    r12,AVR32_RSR_INT3          // get system flags.
    st.w    r10[TASKCONTEXT_SR],r12

loadContext:
    /* change ASID */
    mtsr    AVR32_TLBEHI,r11

    /* load context */
    mov     r10,TASKCONTEXT_BASE
    ldmts   r10,r0-r14                  // restore registers R0-R14
    ld.w    r12,r10[TASKCONTEXT_RAR]    // restore the return-to address

/*mov r8,r12
mov r7,0x100
rcall debug_showMem
1:rjmp 1b*/

    mtsr    AVR32_RAR_INT3,r12
    ld.w    r12,r10[TASKCONTEXT_SR]
    mtsr    AVR32_RSR_INT3,r12          // restore status register

exitSchedulerIRQ:
    rete
.tcZero: .int 0xFFF00C00

////////////////////////////////////
/// PIOC IRQ
///////////////////////////////////
.align 4
intGrp15:
    stm     --sp,r10,r9
    lddpc   r10,.pioc

    /* check if it is for pin 25 */
    ld.w    r9,r10[AVR32_PIO_ISR]
    bld     r9,25
    brne    2f

    /* pin25 changed, we don't care about the status */
    lddpc   r10,.rca
    mov     r9,0
    st.w    r10,r9   
    
2:
    ldm     sp++,r10,r9
    rete
.pioc: .int AVR32_PIOC_ADDRESS
.rca: .int 0x04001100

////////////////////////////////////
/// USART IRQ
////////////////////////////////////
.align 4
intGrp6:
    lddpc   r10,.usart0
    rjmp    allUsart
.align 4
intGrp7:
    lddpc   r10,.usart1
     rjmp    allUsart
.align 4
intGrp8:
    lddpc   r10,.usart2
    rjmp    allUsart
.align 4
intGrp9:
    lddpc   r10,.usart3
    rjmp    allUsart
allUsart:
    ld.w    r11,r10[AVR32_USART_CSR]
    bld     r11,0                                   // check if this is for RXRDY
    brne    1f
    ld.w    r11,r10[AVR32_USART_RHR]                // this will also reset the interrupt flag

1:
    rete
.usart0:        .int AVR32_USART0_ADDRESS
.usart1:        .int AVR32_USART1_ADDRESS
.usart2:        .int AVR32_USART2_ADDRESS
.usart3:        .int AVR32_USART3_ADDRESS
.recvfifo1: .int 0x040010B0

/**********************
** Unrecoverable excetion
**********************/
unrecoverableException:
    mfsr    r9,AVR32_SR
    bfextu  r8,r9,22,3
    cp.w    r8,1                                // are we in supervisor mode? 
    breq    main

    cp.w    r8,0b110                            // is it an exception?
    breq    2f

    SERIALPRINTF("Entering EVBA+0 with unexpected mode: ")
    rcall    debug_showRegister
    1:rjmp 1b

2:
    SERIALPRINTF("Unrecoverable exception at: ")
    mfsr    r8,AVR32_RAR_EX
    rcall   debug_showRegister
    1:rjmp 1b


/**********************
** Unknown exception
**********************/
unknownException:
    SERIALPRINTF("UnknownException at: ")

    mfsr    r8,AVR32_RAR_EX
    rcall   debug_showRegister

    SERIALPRINTF(" number: ")
    mfsr    r8,AVR32_ECR
    rcall   debug_showRegister

    1: rjmp 1b

/**********************
** Supervisor call
** INPUT: r12 = function number
**********************/
supervisorCall:
    stm     --sp,r14
    mov     r14,lo(scallBase)
    orh     r14,hi(scallBase)
    add     r14,r14,r12<<2

    mcall   r14
    ldm     sp++,r14
    rets


/**********************
** Illegal opcode
**********************/
illegalOpcode:
    SERIALPRINTF("Illegal opcode")

    1:rjmp 1b 


/**********************
** Unimplemented instruction
**********************/
unimplmentedInstruction:
    SERIALPRINTF("Unimplmented instruction")

    1:rjmp 1b



/**********************
** init EVBA
**********************/
initEVBA:
    stm     --sp,r7,r8,r9,lr
    /*Init EVBA*/
    lddpc   r8,evbaconstant
    mtsr    AVR32_EVBA,r8

    csrf    AVR32_SR_EM_OFFSET
    ldm     sp++,r7,r8,r9,pc


/**********************
** init Interupts
**********************/
initInterrupts:
    stm     --sp,r7,r8,r9,lr

    ssrf    AVR32_SR_GM_OFFSET
    ssrf    AVR32_SR_I3M_OFFSET
    ssrf    AVR32_SR_I2M_OFFSET
    ssrf    AVR32_SR_I1M_OFFSET
    ssrf    AVR32_SR_I0M_OFFSET


    /* set all ints to a default */
    lddpc   r9,.INTC
    mov     r7,63
    mov     r8,(catchAllInt-evbabase)
1:  st.w    r9++,r8
    sub     r7,1
    brne    1b

    /* init timer0 IRQ */
    mov     r8,((intGrp22-evbabase))                 // set offset
    sbr     r8,31                                   // set level to INT3
    sbr     r8,30                                   // set level to INT3
    lddpc   r9,.INTC
    st.w    r9[(22*4)],r8

    /* init usart0 IRQ */
    mov     r8,((intGrp6-evbabase))                 // set offset
    lddpc   r9,.INTC
    st.w    r9[(6*4)],r8

    /* init usart1 IRQ */
    mov     r8,((intGrp7-evbabase))                 // set offset
    lddpc   r9,.INTC
    st.w    r9[(7*4)],r8

    /* init usart2 IRQ */
    mov     r8,((intGrp8-evbabase))                 // set offset
    lddpc   r9,.INTC
    st.w    r9[(8*4)],r8

    /* init usart3 IRQ */
    mov     r8,((intGrp9-evbabase))                 // set offset
    lddpc   r9,.INTC
    st.w    r9[(9*4)],r8

    /* init PIOC IRQ */
    mov     r8,((intGrp15-evbabase))                 // set offset
    lddpc   r9,.INTC
    st.w    r9[(15*4)],r8


    csrf    AVR32_SR_GM_OFFSET
    csrf    AVR32_SR_I3M_OFFSET
    csrf    AVR32_SR_I2M_OFFSET
    csrf    AVR32_SR_I1M_OFFSET
    csrf    AVR32_SR_I0M_OFFSET
    ldm     sp++,r7,r8,r9,pc

.INTC: .int AVR32_INTC_ADDRESS

evbaconstant: .int EntryPoint
