#include <avr32/io.h>
#include "macro.h"

.global init_pm

init_pm:
    stm     --sp,r0,r1,r2,lr 

    /* set system clock */
    lddpc   r0,.PMADDR
    lddpc   r2,.pllconfig
    st.w    r0[AVR32_PM_PLL0],r2

    /* wait for PLL to be locked */
1:  ld.w    r2,r0[AVR32_PM_ISR]
    bld     r2,0
    brne    1b

    /* set main clock to PLL */
    mov     r2,2
    st.w    r0[AVR32_PM_MCCTRL],r2

    /* set clock for PBA,PBB,HSB and CPU*/
    mov     r2,0x8000                            // HSB = CPU/2
    orh     r2,0x8081                                   // PBB = CPU/4, PBA = CPU/4
    st.w    r0[AVR32_PM_CKSEL],r2

    /* enable modules. See datasheet page 104 */
    mov     r1,0x1FFFF
    st.w    r0[AVR32_PM_HSBMASK],r1
    st.w    r0[AVR32_PM_PBAMASK],r1
    st.w    r0[AVR32_PM_PBBMASK],r1

    ldm     sp++,r0,r1,r2,pc

.pllconfig: .int    (((PLL_MUL-1)<<AVR32_PM_PLLMUL)|\
                    ((PLL_DIV-1)<<AVR32_PM_PLLDIV)|\
                    (4<<AVR32_PM_PLLOPT)|\
                    (1<<AVR32_PM_PLLEN)|\
                    (16<<AVR32_PM_PLLCOUNT))
.PMADDR: .int AVR32_PM_ADDRESS
