#include <avr32/io.h>
#include "macro.h"

.global init_scheduler


// speed: (pll_hz/pbb_div)/AVR32_TC_TCCLKS/AVR32_TC_RC0 : (150MHZ/2)/32/0xFFFF = 34hz 
// which will give us about 4M instructions per time slice
init_scheduler:
    stm     --sp,r6,r7,r8,r9,lr
   
    /* Set channel mode */
    lddpc   r6,.channelMode
    lddpc   r8,.tcZero
    st.w    r8[AVR32_TC_CMR0],r6   

    /* setup timer register C */
    mov     r6,0xFFFF
    st.w    r8[AVR32_TC_RC0],r6

    /* Enable RC compare interrupt */
    mov     r6,0b10000
    st.w    r8[AVR32_TC_IER0],r6

    /* Start timer */
    mov     r6,(1 | (1<<AVR32_TC_SWTRG))
    st.w    r8[AVR32_TC_CCR0],r6

    ldm     sp++,r6,r7,r8,r9,pc
.tcZero:   .int AVR32_TC0_ADDRESS
.channelMode: .int     ((4<<AVR32_TC_TCCLKS)|(2<<AVR32_TC_WAVSEL)|(1<<AVR32_TC_WAVE))



